/**************************************************************
	LCD Hello world
	 for PIC16F88
 **************************************************************
	author air_variable
	http://www.ne.jp/asahi/air/variable/
	version 2.00
	Tools:
	MPLAB IDE ver 8.90
	MPLAB XC8 ver 1.12
---------------------------------------------------------------
Date	:Time	Version	Build	Note
20081123:1900	1.00	---			begin the program
20081123:2130	1.10	---			Use code protect
20081201:2100	1.11	---			modification lcd.c
20091117:0309	1.12	---			fix lcd.c
20130407:1140	2.00	xc8 1.12	correspond the new C complier
---------------------------------------------------------------
Project folder(default)
	C:\picsrc\piccpro\hello_world\hello_16f88
Source Files
	main.c (This file)
	lcd.c
Header Files
	lcd.h	
---------------------------------------------------------------
Pin assignment
	1:RA2:O:LCD DB6
	2:RA3:O:LCD DB7
	3:RA4:OD:No connect(Driven as "0")
	4:MCLR/RA5:I:PICKIT2-1(W/10kPU)
	5:VSS:GND
	6:RB0:I:Not used
	7:RB1:I:Not used
	8:RB2:O:No connect(Driven as "0")
	9:RB3:O:PWM out(Use negative potential)

	18:RA1:O:LCD DB5
	17:RA0:O:LCD DB4
	16:RA7:O:No connect(Driven as "0")
	15:RA6:O:No connect(Driven as "0")
	14:VDD:Power 3 to 5 Volt
	13:RB7:O:LCD E
	12:RB6:O:LCD RS
	11:RB5:I:Not used
	10:RB4:I:Not used
**************************************************************/
//config settings ***2.00
#pragma config BOREN = ON	//BOR enabled
#pragma config CPD = OFF	//Code protection off
#pragma config CCPMX =RB3	//CCP1 function on RB3
#pragma config DEBUG =	OFF	//In-Circuit Debugger disabled
#pragma config WRT =OFF	//Write protection off
#pragma config FOSC =INTOSCIO	//INTRC oscillator
#pragma config MCLRE =OFF	//RA5/MCLR/VPP pin function is digital I/O, MCLR internally tied to VDD
#pragma config WDTE =OFF	//WDT disabled
#pragma config CP =OFF	//Code protection off
#pragma config LVP =OFF	//RB3 is digital I/O, HV on MCLR must be used for programming
#pragma config PWRTE =ON	//PWRT enabled
#pragma config IESO =OFF	//Internal External Switchover mode disabled
#pragma config FCMEN =OFF	//Fail-Safe Clock Monitor disabled

//CN[ht@CݒƁA__delay֐pgݒ
//U8MHzgp
#include <htc.h>
#include "lcd.h"
#define MHz 000000
#define _XTAL_FREQ 8MHz


//RtBO QƐC:\Program Files\Microchip\xc8\v1.12\docs\chips
/*
__CONFIG(
	PROTECT & CCPRB3 & DEBUGDIS & LVPDIS & BORDIS & MCLRDIS & PWRTEN & WDTDIS & INTIO
	);
__CONFIG(
	FCMDIS & IESODIS
	);
*/

//------------------main
void main(void){
//gpϐ̐錾
	unsigned int timer;	//^C}[p(16rbg)
	unsigned char temp;	//ėp(8rbg)	
	unsigned char user_char[]={	//[U[LN^` n[gp^[
		0b00001010,
		0b00011111,
		0b00011111,
		0b00011111,
		0b00011111,
		0b00001110,
		0b00001110,
		0b00000100
	};
//NbNݒ
	OSCCON = 0b01110000;	//8MHz,__configłFOSCݒ
		
//e|[g̏
//		  	  76543210
	PORTA = 0b00000000;		//|[gA
	PORTB = 0b00000000;		//|[gB
	TRISA = 0b00100000; 	//|[gA̕ݒ
	TRISB = 0b00110111; 	//|[gB̕ݒ

	ANSEL = 0x00;			//S|[gfW^Ŏgp
	CMCON = 0x07;			//|[gAfW^I/OƂĎgp
	OPTION_REG = 0b00000111;	//vXP[ݒ 1/256,|[gBvAbvݒ **2.00
	GIE  = 0;				//荞݂͎gpȂ

//PWM initialize setting (41.9KHz on RB3 @4MHz)tɕd^邽߂̃[`
//[RXgLCDVAʐMj^[̃n[hEFAƌ݊ۂ߂̐ݒBʏ͕sv
	CCP1CON = 0b00001100;	// use PWM mode
	PR2 = 0x17; 			// resolution is 6.5bit mode
	CCPR1L = 0x0c; 			// duty is 50%
	T2CON = 0b00000100;		// POSTSCALE 1:1 ,TMR2 ON , PRESCALE 1:1

//ԑ҂id肷܂0.2b҂)
		timer = 20;			//0.01bx20 = 0.2b^C}[ 
		while(timer--){
			__delay_ms(10);
		};

//LCD
	lcd_init();		//LCD
	lcd_clear();	//LCD\NAɂ

//[U[tHgLCDCG RAM֓]
	lcd_write(0x40);				//CG RAM[h 0ԒnZbg
	for (temp=0;temp<8;temp++){
		lcd_putch(user_char[temp]);//CG RAMLN^Zbg(8ij
	}
	lcd_write(0x80);				//DD RAM [hZbg

//\Jn@ivɌJԂ------------------------------
	while(1){

//LCDɍsŕ\
		lcd_goto(0x00);				//LCD̕\ʒuz[|WV
		lcd_write(0x0f);			//J[\\
		lcd_puts("Hello world !");	//LCDɃbZ[W\
		lcd_goto(0x40);				//LCD̕\ʒu2iڂ(SC1602BS̏ꍇ)
		lcd_puts("You can do it!");	//LCDɃbZ[W\
		
//ԑ҂
		timer = 500;	//0.01bx500 = 5b^C}[ 
		while(timer--){
			__delay_ms(10);
		};

//------------------------ʂNA----------------------
//LCDɈꕶ\1i
		lcd_goto(0x00);	//LCD̕\ʒuz[|WV
		lcd_write(0x0c);	//J[\\Ȃ
		temp = 16;	//Zbg
		while(temp--){
			lcd_putch(0x00);	//LCDɃbZ[W\i[U[tHgg)
			timer = 10;	//0.01bx10 = 0.1b^C}[ 
			while(timer--){
				__delay_ms(10);
			};
		};	//16JԂ

//LCDɈꕶ\2i
		temp = 16;	//Zbg
		while(temp--){
			lcd_goto(0x40+temp);	//LCD̕\ʒu𐧌䂵Ȃ
			lcd_putch(0x00);	//LCDɃbZ[W\i[U[tHgg)
			timer = 10;	//0.01bx10 = 0.1b^C}[ 
			while(timer--){
				__delay_ms(10);
			};
		};	//16JԂ

//LCDɈꕶ\1i
		lcd_goto(0x00);	//LCD̕\ʒuz[|WV
		temp = 16;	//Zbg
		while(temp--){
			lcd_putch(' ');	//LCDɃbZ[W\iXy[X)
			timer = 10;	//0.01bx10 = 0.1b^C}[ 
			while(timer--){
				__delay_ms(10);
			};
		};	//16JԂ

//LCDɈꕶ\2i
		temp = 16;	//Zbg
		while(temp--){
			lcd_goto(0x40+temp);	//LCD̕\ʒu𐧌䂵Ȃ
			lcd_putch(' ');	//LCDɃbZ[W\iXy[X)
			timer = 10;	//0.01bx10 = 0.1b^C}[ 
			while(timer--){
				__delay_ms(10);
			};
		};	//16JԂ
	}	//JԂ	
}
